Main Page | Modules | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | Related Pages

# SoIndexedFaceSet Class Reference
[Nodes]

`#include <Inventor/nodes/SoIndexedFaceSet.h>`

Inheritance diagram for SoIndexedFaceSet:

List of all members.

## Detailed Description

The SoIndexedFaceSet class is used to handle generic indexed facesets.

Faces are specified using the coordIndex field. Each face must be terminated by a negative (-1) index. Coordinates, normals, materials and texture coordinates from the current state (or from the vertexProperty node if set), can be indexed to create triangles, quads or polygons.

Here's a usage example of just about the simplest possible use of this node, to show a single polygon face:

      #Inventor V2.1 ascii

      Separator {
         Coordinate3 {
            point [ 0 0 0, 1 0 0, 1 1 0 ]
         }
         IndexedFaceSet {
            coordIndex [ 0, 1, 2, -1 ]
         }
      }

Binding PER_VERTEX_INDEXED, PER_VERTEX, PER_FACE_INDEXED, PER_FACE or OVERALL can be set for material, and normals. The default material binding is OVERALL. The default normal binding is PER_VERTEX_INDEXED. When PER_VERTEX_INDEXED binding is used and the corresponding materialIndex, normalIndex, texCoordIndex field is empty, the coordIndex field will be used to index material, normal or texture coordinate. If you do specify indices for material, normals or texture coordinates for PER_VERTEX_INDEXED binding, make sure your index array matches the coordIndex array (there should be -1 wherever there is a -1 in the coordIndex field. This is done to make this node more human readable.)

A fairly common request when rendering facesets is how to display a set of faces with different colors on the backside versus the frontside. There is not direct support for this in the API, but it can easily be implemented by duplicating all faces in both the SoShapeHints::COUNTERCLOCKWISE and the SoShapeHints::CLOCKWISE order. Here is a simple usage example, showing the technique for a single triangle face:

      #Inventor V2.1 ascii

      Separator {
         Coordinate3 { point [ 0 0 0, 1 0 0, 1 1 0 ] }

         Material { diffuseColor [ 1 0 0, 1 1 0 ] }
         MaterialBinding { value PER_FACE_INDEXED }

         ShapeHints {
            vertexOrdering COUNTERCLOCKWISE
            shapeType SOLID
         }

         IndexedFaceSet {
            coordIndex [ 0, 1, 2, -1, 2, 1, 0, -1 ]
            materialIndex [ 0, 1 ]
         }
      }

See also:
  SoFaceSet, SoIndexedTriangleStripSet

## Public Member Functions
| SoIndexedFaceSet (void)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual SbBool | generateDefaultNormals (SoState *state, SoNormalBundle *bundle)
virtual SbBool | generateDefaultNormals (SoState *state, SoNormalCache *cache)
## Static Public Member Functions
void | initClass (void)
## Protected Member Functions
virtual | ~SoIndexedFaceSet ()
virtual void | generatePrimitives (SoAction *action)

## Constructor & Destructor Documentation

SoIndexedFaceSet::SoIndexedFaceSet | ( | void |  | ) |

| Constructor.

SoIndexedFaceSet::~SoIndexedFaceSet | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoIndexedFaceSet::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoIndexedShape.

void SoIndexedFaceSet::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoShape.

void SoIndexedFaceSet::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) | `[virtual]`

| Action method for the SoGetPrimitiveCountAction. Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action. Nodes influencing how geometry nodes calculates their primitive count also overrides this method to change the relevant state variables. Reimplemented from SoShape.

SbBool SoIndexedFaceSet::generateDefaultNormals | ( | SoState * | state,
|  | SoNormalBundle * | bundle
| ) | `[virtual]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Subclasses should override this method to generate default normals using the SoNormalBundle class. `TRUE` should be returned if normals were generated, `FALSE` otherwise. Default method returns `FALSE`. This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API. Reimplemented from SoVertexShape.

SbBool SoIndexedFaceSet::generateDefaultNormals | ( | SoState * | state,
|  | SoNormalCache * | nc
| ) | `[virtual]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Subclasses should override this method to generate default normals using the SoNormalCache class. This is more effective than using SoNormalGenerator. Return `TRUE` if normals were generated, `FALSE` otherwise. Default method just returns `FALSE`. This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API. Reimplemented from SoVertexShape.

void SoIndexedFaceSet::generatePrimitives | ( | SoAction * | action | ) | `[protected, virtual]`

| The method implements action behavior for shape nodes for SoCallbackAction. It is invoked from SoShape::callback(). (Subclasses should not override SoNode::callback().) The subclass implementations uses the convenience methods SoShape::beginShape(), SoShape::shapeVertex(), and SoShape::endShape(), with SoDetail instances, to pass the primitives making up the shape back to the caller. Implements SoShape.

The documentation for this class was generated from the following files:

- SoIndexedFaceSet.h
- SoIndexedFaceSet.cpp